;;
;; Test cdaudio module
;;

(use gauche.test)
(use cdaudio)

(test-start "cdaudio")

(test* "cd-version ()"
       "libcdaudio 0.99.9"
       (cd-version))

(test* "cd-init-device (\"/dev/sr0\")"
       4
       (cd-init-device "/dev/sr0"))

(test* "cd-stat (4)"
       #t
       (equal? (cd-stat 4) #t))
       ;(equal? (cd-stat 4) #,(discinfo 1 3 0 1 22 0)))

(test* "cd-play (4 3)"
       #t
       (cd-play 4 3))

(test* "cd-play (4 3)"
       #t
       (cd-play 4 3))

(test* "cd-get-volume (4)"
       #t
       (cd-get-volume 4))

(test* "discinfo-* (cd-stat (4))"
       #t
       (let ((di (cd-stat 4)))
	 (list (discinfo-disc-present di)
	       (discinfo-disc-mode di)
	       (discinfo-current-track di)
	       (discinfo-first-track di)
	       (discinfo-total-tracks di))))

(test* "volume-* (volume (4))"
       '(255 255 0 0)
       (let ((vol (cd-get-volume 4)))
	 (list (volume-front-left vol)
	       (volume-front-right vol)
	       (volume-back-left vol)
	       (volume-back-right vol))))

(test* "discinfo-track-pos-minutes (cd-stat (4) 2)"
       #t
       (let ((di (cd-stat 4)))
	 (discinfo-track-pos-minutes di 2)))

(test* "discinfo-track (cd-stat (4) 1)"
       #t
       (let ((di (cd-stat 4)))
	 (discinfo-track di 2)))

(test* "cd-finish (4)"
       #t
       (cd-finish 4))

(test-end)
